<?php
/**
Plugin Name: Akadlymentes tma vlaszt
Plugin URI: 
Description: Lehetv teszi, hogy a felhasznl akadlymentes verzira vltoztassa a tmt.
Author: stevomchun
Version: 1.2.0
Author URI: 
Stable tag: 1.2.0
License: GPL2+
Text Domain: akadalymentes-tema-valaszto
*/

/**
 * Include plugin option page
 */
require_once dirname( __FILE__ ) . '/admin/akadalymentes-tema-valaszto-settings.php';

class Akadalymentes_tema_valaszto{

	public $default_theme;
	public $engedelyezes;
	public $sticky_bar_position;
	public $hide_site_title;
    public $akadalymentes_felirat;
    public $normal_felirat;
    public $cookie_name;
    public $Normal_theme;
	public $Accessability_theme;
	public $hide_credit;
	public $enable_shortcode;
	public $custom_css;
	
	public function __construct(){
		self::init();

		add_action( 'plugins_loaded', array( $this, 'cookie_theme_switch' ) );
		add_action( 'wp_head', array( $this, 'ajax_url' ) );
		/*add_action( 'wp_head', array( $this, 'acc_thm' ) );*/
		/*add_action( 'wp_head', array( $this, 'nrm_thm' ) );*/

		if ( $this->engedelyezes == 'on' ) {
			add_action( 'wp_footer', array( $this, 'sticky_bar' ) );
			add_action( 'wp_head', array( $this, 'custom_css' ), 99 );
		}
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'wp_ajax_akadalymentes_change_theme', array( $this, 'ajax_theme_switch' ) );
		add_action( 'wp_ajax_nopriv_akadalymentes_change_theme', array( $this, 'ajax_theme_switch' ) );
		if( $this->enable_shortcode == 'on' ){
			add_action( 'widget_text', 'do_shortcode' );
			add_shortcode( 'Akadalymentes_tema_valaszto', array( $this, 'Accessability_theme' ) );
		}
        add_action( 'init', 'allow_origin' );
        function allow_origin() {
            header("Access-Control-Allow-Origin: *");
            }
        
	}

	public function init(){
		$this->default_theme = get_option( 'stylesheet' );
		$this->engedelyezes = akadalymentes_get_option( 'engedelyezes', 'Akadalymentes_tema_valaszto', 'off' );
		$this->sticky_bar_position = akadalymentes_get_option( 'sticky_bar_position', 'Akadalymentes_tema_valaszto', 'top' );
		$this->hide_site_title = akadalymentes_get_option( 'hide_site_title', 'Akadalymentes_tema_valaszto', 'off' );
		$this->Accessability_theme = akadalymentes_get_option( 'Accessability_theme', 'Akadalymentes_tema_valaszto', $this->themes_list() );
		$this->Normal_theme = akadalymentes_get_option( 'Normal_theme', 'Akadalymentes_tema_valaszto', $this->themes_list() );
		$this->akadalymentes_felirat = akadalymentes_get_option( 'akadalymentes_felirat', 'Akadalymentes_tema_valaszto', 'Akadlymentestett verzi');
		$this->normal_felirat = akadalymentes_get_option( 'normal_felirat', 'Akadalymentes_tema_valaszto','Vissza a norml verzira');
        $this->cookie_name = akadalymentes_get_option( 'cookie_name', 'Akadalymentes_tema_valaszto','akadalymentes_active_theme');
		$this->hide_credit = akadalymentes_get_option( 'hide_credit', 'Akadalymentes_tema_valaszto', 'off' );
		$this->enable_shortcode = akadalymentes_get_option( 'enable_shortcode', 'Akadalymentes_tema_valaszto', 'off' );
		$this->custom_css = akadalymentes_get_option( 'custom_css', 'Akadalymentes_tema_valaszto', '' );
	}
	public function enqueue_scripts(){
		wp_enqueue_script( 'jquery' );
		wp_enqueue_style( 'akadalymentes-tema-valaszto', plugins_url( 'assets/css/style.css', __FILE__ ) );
		wp_enqueue_script( 'akadalymentes-tema-valaszto', plugins_url( 'assets/js/script.js', __FILE__ ) );
	}

	public function custom_css(){
		$css = "<style type='text/css'>";
		if ( $this->sticky_bar_position == "top" ){
			if( ! is_admin_bar_showing() ){
				$css .= "
				.akadalymentes-tema-valaszto{top : 0px}
				";
			}
			else{
				$css .= "
				html { margin-top: 32px !important; }
				* html body { margin-top: 32px !important; }
				@media screen and ( max-width: 782px ) {
					html { margin-top: 46px !important; }
					* html body { margin-top: 46px !important; }
				}";
			}
		}
		else{
			$css .= ".akadalymentes-tema-valaszto{bottom : 0px}";
		}
		echo("<!--");
	echo ($this->default_theme);
	echo ($this->Accessability_theme);
	echo("-->");
        if ($this->default_theme == $this->Accessability_theme) {
            $css .= ".shift{margin-top: -32px; width: 32px; height: 64px; line-height : 1em;}";
        }
		$css .= $this->custom_css."\n";
		$css .= "</style>";

		echo $css;
	}

	public function ajax_url(){ ?>
		<script type="text/javascript"> //<![CDATA[
			ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
		//]]> 
		</script>
    <?php }       
	 
	public function themes_list(){
		$t_list ='<select class="akadalymentes-choose-theme">';
		if( is_array( $this->available_themes ) ){
			$t_list .='<option disabled >Select a Theme</option>';
			foreach ( $this->available_themes as $stylesheet=>$name ) {
				$t_list .= '<option value="'.$stylesheet.'" '.selected( get_option( 'stylesheet' ), $stylesheet, false ).'>'.$name.'</option>';
			}
		}
		else{
			$t_list .='<option disabled selected >No themes to choose</option>';
		}
		$t_list .= '</select>';

		return $t_list;
	}

	public function sticky_bar(){ ?>
		<div class="akadalymentes-tema-valaszto akadalymentes-position-<?php echo $this->sticky_bar_position; ?>">
			<div class="akadalymentes-row">
                <div class="shift">
                    <?php do_action( 'Akadalymentes_tema_valaszto_sticky_bar' ); ?>
                    <input type="hidden" id="acc_thm" value="<?php echo $this->Accessability_theme?>"/>
                    <input type="hidden" id="nrm_thm" value="<?php echo $this->Normal_theme?>"/>
                    <div class="Acessable_button akadalymentes-position-<?php echo $this->sticky_bar_position; ?>">
                    <img class="Acessable_button" title="<?php echo $this->akadalymentes_felirat; ?>" width="24px" height="24px" src="<?php echo plugins_url( 'assets/img/akadalymentes.png', __FILE__ ); ?>">
                    </div>
                    <div class="Normal_button akadalymentes-position-<?php echo $this->sticky_bar_position; ?>">
                    <img class="Normal_button" title="<?php echo $this->normal_felirat; ?>" width="24px" height="24px" src="<?php echo plugins_url( 'assets/img/normal.png', __FILE__ ); ?>">
                    </div>
                </div>
           </div>
		</div>
	<?php }

	public function ajax_theme_switch(){
		$new_theme = $_POST['new_theme'];
		setcookie($this->cookie_name, $new_theme, time()+2592000, '/');
		/*echo($_COOKIE['tarsulas_akadalymentes_active_theme']);*/
		switch_theme($new_theme);
		die();
	}

	/**
	 * @since 3.0.0
	 */
	public function cookie_theme_switch(){
		if(isset($_COOKIE[$this->cookie_name])){
			switch_theme($_COOKIE[$this->cookie_name]);
		}
		else{
			setcookie($this->cookie_name, $this->default_theme, time()+2592000, '/');
		}
	}

}
new Akadalymentes_tema_valaszto();